# coding:utf-8

#计算风控结果
import re
class IndexComputer:
    funs=[]#公式集合
    def Init(self):
        return ""
    def Compute(self,indexItem):#计算单一指标
        print("================计算风控公式")
        # 如果所有因子有一个为空，返回数据不存在
        i = 0
        X = []
        Y = []
        V = {}
        S = []
        # 1.给indexItem.FactorsValue赋测试值
        for factorkey in indexItem.FactorsValue:
            tempval = indexItem.FactorsValue[factorkey]
            tempval=str(tempval)
            if indexItem.FactorsValue[factorkey] is None:
                print("is None")
                return {"status_key":0,"status_value":"normal"}
            try:
                eval(tempval)
            except:
                print("is isNumeric", indexItem.FactorsValue[factorkey])
                return {"status_key":0,"status_value":"normal"}
            Y.append(float(indexItem.FactorsValue[factorkey]))
            V[factorkey] = str("Y[" + str(i) + "]")
            S.append(factorkey)
            i = i + 1
        S = sorted(S, key=lambda i: len(i), reverse=True)
        j = 0
        gongshi_list = []
        for fun in indexItem.Funs:
            print(indexItem.id, "===============gsid")
            funstr = fun
            for s in S:
                funstr = funstr.replace(s, str(V[s]))
            strinfo = re.compile(r'X\[\d*\]=')
            funstr = strinfo.sub("", funstr)
            gongshi_list.append(funstr)
            try:
                funstr=funstr.replace("[(","((").replace(")]","))")
                val = eval(funstr)
                X.append(val)
                j = j + 1
            except ZeroDivisionError as err:
                print('Handling run-time error:', err)
                return {"status_key":0,"status_value":"normal"}
            except(ValueError):
                print('other:', ValueError)
                return {"status_key":0,"status_value":"normal"}
            except:
                return {"status_key": 0, "status_value": "normal"}
        print(j - 1,"=====j - 1")
        if X[j - 1] == False:
            if indexItem.Name in ["销售额变动率","销售毛利（益）率","税收负担率","税收负担变动率"]:
                last_gongshi = gongshi_list[-1]
                print(last_gongshi, "=========last_gongshi")
                # 2.以and进行分割
                last_gongshi=last_gongshi.split("and")
                print(last_gongshi[0],last_gongshi[1],"=====aaa")
                print(eval(last_gongshi[0]),"=====eval1")
                print(eval(last_gongshi[1]), "=====eval2")
                if eval(last_gongshi[0])==True and eval(last_gongshi[1])==False:
                    return {"status_key": 2, "status_value": "big"}
                else:
                    return {"status_key": 2, "status_value": "small"}
            else:
                return {"status_key":2,"status_value":"normal"}
        else:
            return {"status_key":1,"status_value":"normal"}


    def finance_Compute(self, indexItem):
            finance_result = {}
            i = 0
            X = []
            Y = []
            V = {}
            S = []
            for factorkey in indexItem.FactorsValue:
                tempval = indexItem.FactorsValue[factorkey]
                print(factorkey,tempval,'===============factorkey,tempval')
                try:
                    eval(tempval)
                except Exception as e:
                    print(e, "======eval抛出财务异常")
                    return '—'
                Y.append(float(indexItem.FactorsValue[factorkey]))
                V[factorkey] = str("Y[" + str(i) + "]")
                S.append(factorkey)
                i = i + 1
            S = sorted(S, key=lambda i: len(i), reverse=True)
            j = 0
            for fun in indexItem.Funs:
                funstr = fun
                for s in S:
                    funstr = funstr.replace(s, str(V[s]))
                strinfo = re.compile(r'X\[\d*\]=')
                funstr = strinfo.sub("", funstr)
                try:
                    print("计算正常公式")
                    if type(funstr) == str:
                        val = eval(funstr)
                    else:
                        val = funstr
                    X.append(val)
                    j = j + 1
                except ZeroDivisionError as err:
                    print("计算异常公式时")
                    print('finance error:', err)
                    return "∞"
                Finance_result = X[j - 1]
                if Finance_result ==0.0:
                    Finance_result= int(Finance_result)
                else:
                    Finance_result=Finance_result
                return Finance_result